{start.cislo:40}
unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls;

const
  tways=['S',':','C'];
  pS='S';
  pW=':';
  pC='C';
type
  tpathway=record
    posx,posy:integer;
    speedx,speedy:integer;
    step:integer;
    lastpX:array[0..255*10]of integer;
    lastpY:array[0..255*10]of integer;
    lastp:integer;
  end;
type
  TForm1 = class(TForm)
    GroupBox1: TGroupBox;
    Button1: TButton;
    Label1: TLabel;
    Label2: TLabel;
    Button2: TButton;
    OpenDialog1: TOpenDialog;
    SaveDialog1: TSaveDialog;
    Button3: TButton;
    Image1: TImage;
    Memo1: TMemo;
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure FormResize(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;
  map:array of array of char;
  buffer:array of tpathway;
  bufferp:integer;
  mapsx,mapsy,max:integer;
implementation

{$R *.dfm}
procedure mapshow(image:timage;color:tcolor;x,y,max:integer);
var
size:integer;
begin
  if image.Width<image.Height then
    size:=image.Width
  else
    size:=image.Height;
  size:=size div max;
  image.Canvas.Brush.Color:=color;
  image.Canvas.Brush.Style:=bsSolid;
  image.Canvas.Pen.Color:=color;

  image.Canvas.Rectangle(x*size,y*size,(x+1)*size,(y+1)*size);
end;
function testNext2(posx,posy,speedx,speedy,buffid:integer):boolean; {vraci o kolik se musi zmenit pozice}
var
i:integer;

begin
{}

if(posy+speedy <0)or(posx+speedx<0)or(posy+speedy>mapsy)or(posx+speedx>mapsx) then
  begin

  result:=false;
  end
  else
    begin
      if map[posy+speedy,posx+speedx]='C' then
        begin
          for i:=0 to buffer[buffid].lastp do
            begin
            mapshow(form1.image1,clPurple+i*5,buffer[buffid].lastpX[i],buffer[buffid].lastpY[i],max);
        //application.ProcessMessages;
        //sleep(100);
            end;

        //showmessage('Ulozeno');
       // bufferp:=-1;
       // exit;
        end;

      

        if map[posy+speedy,posx+speedx]='X' then
          result:=false
        else
          result:=true;
    end;
end;

function testNext(posx,posy,speedx,speedy,buffid:integer):boolean; {vraci o kolik se musi zmenit pozice}
var
i:integer;
txt:tstringlist;
begin
{}

if(posy+speedy <0)or(posx+speedx<0)or(posy+speedy>mapsy)or(posx+speedx>mapsx) then
  begin

  result:=false;
  end
  else
    begin
      if map[posy+speedy,posx+speedx]='C' then
        begin
          txt:=tstringlist.Create;
          for i:=1 to buffer[buffid].lastp do
            begin
              txt.Add(inttostr(buffer[buffid].lastpX[i]-buffer[buffid].lastpX[i-1])+','+inttostr(buffer[buffid].lastpY[i]-buffer[buffid].lastpY[i-1]));
            mapshow(form1.image1,clPurple+i*5,buffer[buffid].lastpX[i],buffer[buffid].lastpY[i],max);
        //application.ProcessMessages;
        //sleep(100);
            end;
        txt.Add(inttostr(speedx)+','+inttostr(speedy));
        txt.SaveToFile(form1.savedialog1.filename);
        showmessage('Ulozeno');
        bufferp:=-1;
        exit;
        end;

      result:=true;
      for i:=0 to buffer[buffid].lastp do
        begin
          if (buffer[buffid].lastpX[i]=posx+speedx)and(buffer[buffid].lastpY[i]=posy+speedy) then
            result:=false;
      
        end;
      if result<>false then
        if map[posy+speedy,posx+speedx]='X' then
          result:=false
        else
          result:=true;
    end;
end;

procedure go(buffid:integer);
var       //posx,posy,speedx,speedy:integer;lastpX,lastpY:array of integer;lastp:integer
  dx,dy,vpoint,i:integer;
  posx,posy,speedx,speedy:integer;
  validX,validY:array[0..255] of integer;

  lastp,y:integer;
begin
{}

posx:=buffer[buffid].posx;
posy:=buffer[buffid].posy;
//form1.memo1.lines.add(inttostr(posx)+';'+inttostr(posy));
//sleep(300);

mapshow(form1.image1,clPurple,posx,posy,max);
//sleep(100);
        application.ProcessMessages;

speedx:=buffer[buffid].speedx;
speedy:=buffer[buffid].speedy;
//posx:=posx+speedx;
//posy:=posy+speedy;
buffer[buffid].lastp:=buffer[buffid].lastp+1;
buffer[buffid].lastpX[buffer[buffid].lastp]:=buffer[buffid].posx;
buffer[buffid].lastpY[buffer[buffid].lastp]:=buffer[buffid].posy;
vpoint:=0;

for dx:=-1 to 1 do
  for dy:=-1 to 1 do
    begin
      if (dx=0)and(dy=0) then
        continue;
      //test jestli pri pokr.stejnou rychlosti narazime
      if(testNext2(posx+speedx,posy+speedy,speedx+speedx,speedy+speedy,buffid)=false)then
        begin
        speedx:=0;
        speedy:=0;
        end;
      //test jestli pri zmene rychlosti vyjedem z drahy
      if testNext(posx+speedx,posy+speedy,speedx+dx,speedy+dy,buffid) then
        begin


         { if(testNext2(posx+speedx,posy+speedy,speedx+speedx,speedy+speedy,buffid)=false)then
            begin
              validX[vpoint]:=0;
              validY[vpoint]:=0;
              vpoint:=vpoint+1;
            end
          else
            begin }
              validX[vpoint]:=dx;
              validY[vpoint]:=dy;
              vpoint:=vpoint+1;
            //end;
        end;
    end;

for i:=0 to vpoint-1 do
  begin

    buffer[bufferp].posx:=posx+speedx;
    buffer[bufferp].posy:=posy+speedy;
    buffer[bufferp].speedx:=speedx+validX[i];
    buffer[bufferp].speedy:=speedy+validY[i];
    buffer[bufferp].lastp:=buffer[buffid].lastp;
    buffer[bufferp].lastpX:=buffer[buffid].lastpX;
    buffer[bufferp].lastpY:=buffer[buffid].lastpY;
    bufferp:=bufferp+1;
  end;    

end;






procedure TForm1.Button2Click(Sender: TObject);
begin
if savedialog1.Execute then
        label2.Caption:=savedialog1.FileName;
end;


procedure showmap();
var
  mapf:tstringlist;
  i,y:integer;
  actp,start,finish:tpoint;
  tempx,tempy:integer;
begin
{nacteni mapy a jeji zobrazovani}
mapf:=tstringlist.Create;
mapf.LoadFromFile(form1.opendialog1.FileName);
max:=length(mapf[0]);
mapsx:=max-1;

setlength(map,mapf.Count);
for i:=0 to mapf.count-1 do
  begin
    mapsy:=length(mapf[i])-1;
    setlength(map[i],length(mapf[i]));
    for y:=1 to length(mapf[i]) do
      begin
        map[i,y-1]:=mapf[i][y];
        if mapf[i][y]='X' then
          mapshow(form1.image1,clblack,y-1,i,max);
        if mapf[i][y]='S' then
          begin
          mapshow(form1.image1,clRed,y-1,i,max);
          start.x:=y-1;
          start.y:=i;
          end;
        if mapf[i][y]='C' then
          begin
          mapshow(form1.image1,clGreen,y-1,i,max);
          finish.x:=y-1;
          finish.y:=i;
          end;
        if mapf[i][y]='.' then
          mapshow(form1.image1,clWhite,y-1,i,max);
        if mapf[i][y]=':' then
          mapshow(form1.image1,clGray,y-1,i,max);
      end;
  end;
end;

procedure TForm1.Button3Click(Sender: TObject);
var
  mapf:tstringlist;
  i,y:integer;
  actp,start,finish:tpoint;
  tempx,tempy:integer;
begin
{nacteni mapy a jeji zobrazovani}
mapf:=tstringlist.Create;
mapf.LoadFromFile(opendialog1.FileName);
max:=length(mapf[0]);
mapsx:=max-1;

setlength(map,mapf.Count);
for i:=0 to mapf.count-1 do
  begin
    mapsy:=length(mapf[i])-1;
    setlength(map[i],length(mapf[i]));
    for y:=1 to length(mapf[i]) do
      begin
        map[i,y-1]:=mapf[i][y];
        if mapf[i][y]='X' then
          mapshow(image1,clblack,y-1,i,max);
        if mapf[i][y]='S' then
          begin
          mapshow(image1,clRed,y-1,i,max);
          start.x:=y-1;
          start.y:=i;
          end;
        if mapf[i][y]='C' then
          begin
          mapshow(image1,clGreen,y-1,i,max);
          finish.x:=y-1;
          finish.y:=i;
          end;
        if mapf[i][y]='.' then
          mapshow(image1,clWhite,y-1,i,max);
        if mapf[i][y]=':' then
          mapshow(image1,clGray,y-1,i,max);
      end;
  end;
{zprac.cesty}
memo1.Lines.Clear;
actp:=start;
setlength(buffer,10000);
buffer[0].posx:=start.X;
buffer[0].posy:=start.Y;
buffer[0].speedx:=0;
buffer[0].speedy:=0;
buffer[0].lastp:=-1;

repeat
  tempx:=buffer[bufferp].posx;
  tempy:=buffer[bufferp].posy;  
  
  go(0);

  for i:=1 to bufferp do
    begin
      buffer[i-1]:=buffer[i];
    end;   
  bufferp:=bufferp-1;
  

until bufferp<0;

end;

procedure TForm1.FormResize(Sender: TObject);
begin
if fileexists(opendialog1.FileName) then
  showmap();
end;

procedure TForm1.Button1Click(Sender: TObject);
begin
if opendialog1.Execute then
        label1.Caption:=opendialog1.FileName;
showmap();
end;

end.
